message endpoint [val|->C{end}]
message endpoint2 [val|->~C{dummystate}]

contract C {
  initial state begin {
    !endpoint->end;
  }
  final state end {
    ?endpoint->dummystate;
  }
  state dummystate {
    ?endpoint2->dummystate;
  }
}

/* This function should always fault at the last line:
 * endpoints cannot be dispose()'d */
dispose_ep(e) [e|->C{begin}] {
  local x;
  x = new();
  dispose(x);
  dispose(e);
} [emp]

sender(e) [e|->C{begin}] {
  send(endpoint,e,e);
} [emp]

receiver(e,f) [f|->~C{begin},pr:e] {
  local e1, ee, ff, x;
  e1 = receive(endpoint,f);
  (ee,ff)=open(C);
  if (e==f) dispose(x);
  if (e==ee) dispose(x);
  if (e==ff) dispose(x);
  close(ee,ff);
  if (e==e1) close(e1,f); 
  else {send(endpoint,f,e1);send(endpoint2,f,f);}
} [emp]

principal() [emp] {
  local e, f;
  (e,f)=open(C);
  sender(e)||receiver(e,f);
} [emp]
