open Misc
open Parsetree
open Symbtree

val ctt_find_init : string -> Location.t -> c_state list -> ident
val ctt_find_finals : c_state list -> IdSet.t
val ctt_mk_send_transitions : c_state list -> ctt_transition list
val ctt_mk_receive_transitions : c_state list -> ctt_transition list
val ctt_find : contract list -> ident -> contract
val ctt_walk : contract -> direction -> ident -> ident -> string -> ident
val ctt_walkall : contract -> direction -> ident -> IdSet.t -> string -> IdSet.t
val ctt_is_final : contract -> ident -> bool
val ctt_check_leakage : string -> Location.t -> IdSet.t -> c_state list -> unit
val ctt_view_dot : string -> c_state list -> unit
